/* /////////////////////////////////////////////////////////////////////////////

                  RECEPTEUR RADIO FM  87.5 / 108 MHz
Utilisant une module TEA 5767 Avec preamplificateur BF et Amplificateur BF LM386
avec afficheur LCD NOKIIA 5110.
                Possibilité de memoriser 3 stations

                  La suite ici ->  http://f5mna.free.fr

Septembre 2015

*///////////////////////////////////////////////////////////////////////////////
#include <Wire.h>
#include <EEPROM.h>

//LCD Nokia 5110
#include <SPI.h>
#include <Adafruit_GFX.h>
#include <Adafruit_PCD8544.h>
Adafruit_PCD8544 display = Adafruit_PCD8544(8, 9, 10, 11, 12);
// pin 8 - Serial clock out (SCLK)
// pin 9 - Serial data out (DIN)
// pin 10 - Data/Command select (D/C)
// pin 11 - LCD chip select (CS)
// pin 12 - LCD reset (RST)

unsigned char frequencyH;
unsigned char frequencyL;
unsigned int frequencyB;
double frequency;
double tunerFrequency;

const int btn_avance = 7;//Bouton recherche + nelle station.
const int btn_retour = 6;//Bouton recherche - nelle station.
const int btn_memo1  = 5;//Bouton memoire 1.
const int btn_memo2  = 4;//Bouton memoire 2.
const int btn_memo3  = 3;//Bouton memoire 3.
const int btn_memo   = 2;//Bouton mise en mémoire.

unsigned char buffer[10];
int Frequ;
double freq;
double f;

void setup()
{ 
  Serial.begin (9600);
  
  pinMode(btn_avance, INPUT);
  pinMode(btn_retour, INPUT);
  pinMode (btn_memo1, INPUT);
  pinMode (btn_memo2, INPUT);
  pinMode (btn_memo3, INPUT);
  pinMode( btn_memo, INPUT);

  Wire.begin();
 
  frequency = EEPROM.read(1);
  freq = EEPROM.read(2);
  freq = freq / 10;
  frequency = frequency + freq; 
  frequency = 93.7;
  setFrequency();
  
  display.begin();
  display.setContrast(35); //ajuster le contraste 55//////////////////////////////
  display.clearDisplay();
  display.setTextSize(1);
 }
void setFrequency() {
  tunerFrequency = ((int)(frequency * 10)) / 10.0;
  frequencyB = 4 * (tunerFrequency * 1000000 + 225000) / 32768;
  frequencyH = frequencyB >> 8;
  frequencyL = frequencyB;
  Wire.beginTransmission(0x60);
  delay (200);

  Wire.write(frequencyH);
  Wire.write(frequencyL);
  //Wire.write(0x1A); 
  Wire.write(0xB0);
  Wire.write(0x10);
  Wire.write(0x00);
  Wire.endTransmission();
}

void loop()
{
  display.clearDisplay();
  display.setTextColor(BLACK);
  if (frequency > 99.9)  display.setCursor( 6, 15);
  if (frequency < 100)   display.setCursor( 18, 15);
  display.setTextSize(2);
  display.print(frequency, 1);
  display.setTextSize(1);
  display.println("MHz"); 
  display.display();

  ///////////  Avance  ////////////
  /////////////////////////////////
  {
    int reading1 = digitalRead(btn_avance); 
        if (reading1 == HIGH) {          
        frequency = frequency - f;
        delay (250);
        if (frequency < 87.5) (frequency = 108);
        setFrequency();
  }

    ///////////  Retour  //////////////
    //////////////////////////////////

      int reading2 = digitalRead(btn_retour);
          if (reading2 == HIGH) {
          frequency = frequency + f;
          if (frequency > 108) (frequency = 87.5);
          delay (250);
          setFrequency();
        }
    }
     ///////////////////////////
     //////     PAS  ///////////
     int reading6 = digitalRead(btn_memo);
     if (reading6 == LOW)  f = 0.1;  // Pas 
     if (reading6 == HIGH) f = 1;

    ///////////////////////////////////////    
    /////  Selection écoute mémoires   ////
    ///////////////////////////////////////
    ///// 1
         int reading3 = digitalRead(btn_memo1);
          if ((reading3 == HIGH)&& (reading6 == LOW)) {
            frequency = EEPROM.read(1);
            freq = EEPROM.read(2);
            freq = freq / 10;
            frequency = (frequency + freq );
            setFrequency();         
            }
            
      ////// 2
      int reading4 = digitalRead(btn_memo2);
           if ((reading4 == HIGH)&& (reading6 == LOW)) {
            frequency = EEPROM.read(3);
            freq = EEPROM.read(4);
            freq = freq / 10;
            frequency = (frequency + freq ) ;
            setFrequency ();
        }
     
      ////// 3
      int reading5 = digitalRead(btn_memo3);
          if ((reading5 == HIGH) && (reading6 == LOW))   {
            display.display();
            frequency = EEPROM.read(5);
            freq = EEPROM.read(6);
            freq = freq / 10;
            frequency = (frequency + freq);
            setFrequency();
        }

           if (reading6 == LOW)  f = 0.1;  // Pas 
           if (reading6 == HIGH) f = 1;


    ////////////////////////////////////////
    /////////  Mise en Mémoire  ////////////     
    ////////////////////////////////////////

    if ((reading3 == HIGH) && (reading6 == HIGH)) {
    Frequ = frequency;
    freq = (((frequency - Frequ) * 10) + 0.1);
    EEPROM.write (1, frequency);
    EEPROM.write (2, freq);      
    Serial.print ("Memoire 1: ");
    Serial.print (frequency);
    Serial.println (" MHz");
    delay (500);
    setFrequency();    
  }

   if ((reading4 == HIGH) && (reading6 == HIGH)) {  //Mémorisation 2
    Frequ = frequency;
    freq = (((frequency - Frequ) * 10) + 0.1);
    EEPROM.write (3, frequency);
    EEPROM.write (4, freq);
    Serial.print ("Memoire 2: ");
    Serial.print (frequency);
    Serial.println (" MHz");
    delay (500);
    setFrequency();
  }

    if ((reading5 == HIGH) && (reading6 == HIGH)) { //Mémorisation 3
    Frequ = frequency;
     freq = (((frequency - Frequ) * 10) + 0.1);
    EEPROM.write (5, frequency);
    EEPROM.write (6, freq);
    Serial.print ("Memoire 3: ");
    Serial.print (frequency);
    Serial.println (" MHz");
    delay (500);
    setFrequency();
  }  
 }





